from dataclasses import dataclass
from typing import Any

import numpy as np

from armarx_memory.aron.data.variant import AronDict


@dataclass
class AronDTOBase:

    @classmethod
    def fromAron(cls, d: AronDict):
        raise NotImplementedError()
    
    def toAron(self, path: list[str]) -> AronDict:
        raise NotImplementedError()
    
    def toNDArray(self) -> tuple[np.ndarray, Any]:  # the structure is a DTO, so we would need recursive mapping here
        raise NotImplementedError()
    
    def fromNDArray(self, n: np.ndarray, s: Any):  # the structure is a DTO, so we would need recursive mapping here
        raise NotImplementedError()
