from dataclasses import dataclass

from armarx_memory.aron.type.variant import AronDict, AronString
from armarx_memory.aron.data.dto.common.helper.pose import Pose


@dataclass
class FramedPose(Pose):
    frame: str = ""
    agent: str = ""

    @classmethod
    def fromAron(cls, d: AronDict):
        pose = Pose.fromAron(d.at["poseInFrame"])

        agent = d.at["agentName"]
        assert isinstance(agent, AronString)

        frame = d.at["frameName"]
        assert isinstance(frame, AronString)

        return cls(pose.pose, frame.value, agent.value)
    
