from dataclasses import dataclass

from armarx_memory.aron.data.variant import AronDict, AronString
from armarx_memory.aron.data.dto.aron_dto import AronDTOBase


@dataclass
class PackagePath(AronDTOBase):
    package: str = ""
    path: str = ""

    @classmethod
    def fromAron(cls, d: AronDict):
        package = ""
        path = ""

        package = d.at["package"]
        assert isinstance(package, AronString)

        path = d.at["path"]
        assert isinstance(path, AronString)

        return cls(package.value, path.value)
    
    def toAron(self, path) -> AronDict:
        root: AronDict = AronDict(path=path)
        package: AronString = AronString(value=self.package, path=path + ["package"])
        path: AronString = AronString(value=self.path, path=path + ["path"])

        root.add("package", package)
        root.add("path", path)
        return root