from dataclasses import dataclass

from armarx_memory.aron.data.dto.common.framed_pose import FramedPose
from armarx_memory.aron.data.dto.common.helper.pose import Pose

from armarx_memory.aron.type.variant import AronDict
from armarx_memory.aron.data.dto.aron_dto import AronDTOBase


@dataclass
class ObjectPose(AronDTOBase):
    pose: FramedPose

    @classmethod
    def fromAron(cls, d: AronDict):

        pose = d.at("pose")
        assert isinstance(pose, AronDict)

        attachment = pose.at("attachment")
        fp = FramedPose.fromAron(attachment)

        if fp.frame == "" and fp.agent == "":
            p = Pose.fromAron(pose.at("objectPoseGlobal"))
            fp.pose = p.pose
        
        return cls(fp)