from dataclasses import dataclass

from armarx_memory.aron.data.variant import AronDict
from armarx_memory.aron.data.dto.aron_dto import AronDTOBase
from armarx_memory.aron.data.dto.common.package_path import PackagePath


@dataclass
class Description(AronDTOBase):
    packagePath: PackagePath

    @classmethod
    def fromAron(cls, d: AronDict):

        xml = d.at("xml")
        assert isinstance(xml, AronDict)

        pp = PackagePath.fromAron(xml)

        return cls(pp)
    
    def toAron(self, path) -> AronDict:
        root: AronDict = AronDict(path=path)
        xml: AronDict = self.pp.toAron(path + ["xml"])

        root.add("xml", xml)
        return root