from dataclasses import dataclass

import numpy as np

from armarx_memory.aron.data.variant import AronDict
from armarx_memory.aron.data.dto.aron_dto import AronDTOBase
from armarx_memory.aron.data.dto.common.helper.pose import Pose


@dataclass
class PlatformPose(AronDTOBase):
    pose: Pose

    @classmethod
    def fromAron(cls, d: AronDict):
        trans = d.at("transform")
        
        pose = Pose.fromAron(trans)

        return cls(pose)
    
    def toNDArray(self) -> np.ndarray:
        return self.pose.toNDArray() 