from dataclasses import dataclass, field
from typing import Any


# prototype
@dataclass
class AronInt:
    pass
@dataclass
class AronLong:
    pass
@dataclass
class AronFloat:
    pass
@dataclass
class AronDouble:
    pass
@dataclass
class AronString:
    pass
@dataclass
class AronBool:
    pass
@dataclass
class AronMatrix:
    pass
@dataclass
class AronQuaternion:
    pass
@dataclass
class AronImage:
    pass
@dataclass
class AronPointCloud:
    pass
@dataclass
class AronNDArray:
    pass
@dataclass
class AronList:
    pass
@dataclass
class AronDict:
    pass
@dataclass
class AronTuple:
    pass
@dataclass
class AronObject:
    pass

# typing alias
AronType = AronInt | AronLong | AronFloat | AronDouble | AronBool | AronString | \
        AronMatrix | AronQuaternion | AronImage | AronPointCloud | \
        AronList | AronDict | AronTuple | AronObject

# ARON primitive types
@dataclass
class AronInt(AronInt):
    path: list[str] = field(default_factory=list) 

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_INT"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_INT", "received wrong type for aron int"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)
    
@dataclass
class AronLong(AronLong):
    path: list[str] = field(default_factory=list) 

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_LONG"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_LONG", "received wrong type for aron long"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)
    
@dataclass
class AronFloat(AronFloat):
    path: list[str] = field(default_factory=list) 

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_FLOAT"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_FLOAT", "received wrong type for aron float"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)

@dataclass
class AronDouble(AronDouble):
    path: list[str] = field(default_factory=list) 

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_DOUBLE"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_DOUBLE", "received wrong type for aron double"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)

@dataclass
class AronString(AronString):
    path: list[str] = field(default_factory=list)

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_STRING"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_STRING", "received wrong type for aron string"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)
    
@dataclass
class AronBool(AronBool):
    path: list[str] = field(default_factory=list)

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_BOOL"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_BOOL", "received wrong type for aron bool"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)

# ARON ndarray types
@dataclass
class AronMatrix(AronMatrix):
    rows: int
    cols: int
    elementType: str
    path: list[str] = field(default_factory=list)
    # defaultValue

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_MATRIX"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_MATRIX", "received wrong type for aron matrix"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)
    
@dataclass
class AronQuaternion(AronQuaternion):
    elementType: str
    path: list[str] = field(default_factory=list)
    # defaultValue

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_QUATERNION"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_QUATERNION", "received wrong type for aron quaternion"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)
    
@dataclass
class AronImage(AronImage):
    pixelType: str
    path: list[str] = field(default_factory=list)
    # defaultValue

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_IMAGE"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_IMAGE", "received wrong type for aron image"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)

@dataclass
class AronPointCloud(AronPointCloud):
    voxelType: str
    path: list[str] = field(default_factory=list)
    # defaultValue

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_POINTCLOUD"
        }
        return j

    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_POINTCLOUD", "received wrong type for aron pointcloud"
        path: list[str] = j["_ARON_PATH"]
        return cls(path)

@dataclass
class AronNDArray(AronNDArray):
    dimensions: int
    elementType: str
    path: list[str] = field(default_factory=list) 
    # defaultValue

# ARON container types
@dataclass
class AronList(AronList):
    acceptedType: AronType = field(default_factory=lambda: None) # TODO
    path: list[str] = field(default_factory=list)

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_ELEMENTS": [],
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_LIST"
        }

        return j
    
    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_LIST", "received wrong type for aron list"
        path: list[str] = j["_ARON_PATH"]

        return cls(path)

@dataclass
class AronDict(AronDict):
    acceptedType: AronType = field(default_factory=lambda: None) # TODO
    path: list[str] = field(default_factory=list) 

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_ELEMENTS": {},
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_DICT"
        }

        return j
    
    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_DICT", "received wrong type for aron dict"

        path: list[str] = j["_ARON_PATH"]

        return cls(path)
    
@dataclass
class AronTuple(AronTuple):
    elementTypes: list[AronType]
    path: list[str] = field(default_factory=list)

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_ELEMENTS": {},
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_TUPLE"
        }

        return j
    
    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_TUPLE", "received wrong type for aron tuple"

        path: list[str] = j["_ARON_PATH"]

        return cls(path)
    
@dataclass
class AronObject(AronObject):
    templates: list[str]
    objectName: str
    parent: AronObject
    templateInstantiations: list[str]
    elementTypes: dict[str, AronType] = field(default_factory=dict) 
    path: list[str] = field(default_factory=list) 

    def at(self, s: str):
        return self.elementTypes[s]

    def toJSON(self) -> dict[str, Any]:
        j = {
            "_ARON_ELEMENTS": {},
            "_ARON_PATH": self.path,
            "_ARON_TYPE": "_ARON_OBJECT"
        }

        for k, v in self.elementTypes.items():
            j["_ARON_PATH"] = self.path + [k]

            if isinstance(v, AronType):
                j["_ARON_ELEMENTS"][k] = v.toJSON()
            else:
                j["_ARON_ELEMENTS"][k] = v

        return j
    
    @classmethod
    def fromJSON(cls, j: dict[str, Any]):
        assert j["_ARON_TYPE"] == "_ARON_OBJECT", "received wrong type for aron object"

        elements: dict[str, Any] = {}
        path: list[str] = j["_ARON_PATH"]

        for k, v in j["_ARON_ELEMENTS"].items():
            if v["_ARON_TYPE"] == "_ARON_INT":
                d = AronInt.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_LONG":
                d = AronLong.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_FLOAT":
                d = AronFloat.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_DOUBLE":
                d = AronDouble.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_STRING":
                d = AronString.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_BOOL":
                d = AronBool.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_MATRIX":
                d = AronMatrix.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_QUATERNION":
                d = AronQuaternion.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_IMAGE":
                d = AronImage.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_POINTCLOUD":
                d = AronPointCloud.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_LIST":
                d = AronList.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_DICT":
                d = AronDict.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_TUPLE":
                d = AronTuple.fromJSON(v)
                elements[k] = d
            elif v["_ARON_TYPE"] == "_ARON_OBJECT":
                d = AronObject.fromJSON(v)
                elements[k] = d
            elif v == None:
                raise Exception("Found NULL member in aron type.")
            else:
                raise Exception("No valid aron type found. Received: " + v["_ARON_TYPE"])

        return cls(path, elements)


if __name__ == "__main__":
    # Note: Due to the forward declarations, the arguments of AronType are not
    # the same type objects as the final AronInt, ...
    # assert((AronType.__args__[0] != AronInt)
    
    x = AronInt()

    print(AronType.__args__[0])
    print(isinstance(x, AronInt))
    print(isinstance(x, AronType.__args__[0]))

    print("---------------")

    print(AronType.__args__[0])
    print(AronType.__args__[0] == AronInt)